summaryrefslogtreecommitdiffstats
path: root/rawtherapee
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2011-08-12 14:53:16 +0000
committer Eric Hameleers <alien@slackware.com>2011-08-12 14:53:16 +0000
commit0caeeb21c3a7f1e9884b054e190c7495f165eac9 (patch)
treebc46712a9a540e51bcb5299c51ab0b82542622b0 /rawtherapee
parentf9f20343502707d9acd2ffa36eb0901996d19500 (diff)
downloadasb-0caeeb21c3a7f1e9884b054e190c7495f165eac9.tar.gz
asb-0caeeb21c3a7f1e9884b054e190c7495f165eac9.tar.xz
Initial revision
Diffstat (limited to 'rawtherapee')
-rwxr-xr-xrawtherapee/build/rawtherapee.SlackBuild281
-rw-r--r--rawtherapee/build/slack-desc19
-rw-r--r--rawtherapee/build/slack-required5
3 files changed, 305 insertions, 0 deletions
diff --git a/rawtherapee/build/rawtherapee.SlackBuild b/rawtherapee/build/rawtherapee.SlackBuild
new file mode 100755
index 00000000..9e56bcf0
--- /dev/null
+++ b/rawtherapee/build/rawtherapee.SlackBuild
@@ -0,0 +1,281 @@
+#!/bin/sh
+# $Id$
+# Copyright 2011 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: rawtherapee
+# Descr: Raw image processing software
+# URL: http://rawtherapee.com/
+# Needs: glibmm, gtkmm, libsigc++, libiptcdata
+# Changelog:
+# 3.0.0-1: 12/Aug/2011 by Eric Hameleers <alien@slackware.com>
+# * Initial build. No official source release, so I have to
+# checkout from a mercurial branch.
+#
+# Run 'sh rawtherapee.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# Set initial variables:
+
+PRGNAM=rawtherapee
+VERSION=${VERSION:-3.0}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
+
+DOCS="AUTHORS.txt AboutThisBuild.txt COMPILE.txt LICENSE.txt \
+ doc/built/pdf/en/*.pdf"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# If you want automatic download to work, supply a URL for 'SRCURL' below:
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.xz"
+SRCURL=""
+
+# Use the src_checkout() function if no downloadable tarball exists.
+# This function checks out sources from SVN/CVS and creates a tarball of them.
+src_checkout() {
+ # Param #1 : index in the SOURCE[] array.
+ # Param #2 : full path to where SOURCE[$1] tarball should be created.
+ # Determine the tarball extension:
+ PEXT=$(echo "${2}" | sed -r -e 's/.*[^.].(tar.xz|tar.gz|tar.bz2|tgz).*/\1/')
+ case "$PEXT" in
+ "tar.xz") TARCOMP="J" ;;
+ "tar.gz") TARCOMP="z" ;;
+ "tgz") TARCOMP="z" ;;
+ "tar.bz2") TARCOMP="j" ;;
+ *) echo "Archive can only have extension 'tar.xz', '.tar.gz' '.tar.bz2' or '.tgz'" ; exit 1 ;;
+ esac
+ # Determine the directory name to create for the archive root:
+ PBASE=$(basename ${2} .${PEXT})
+ # Determine the directory where we create our checkout:
+ CODIR=$(dirname ${2})
+ case ${1} in
+ 0) # This is a mercury repository checkout:
+ # Either use a revision or a branch:
+ if [ "$(echo ${VERSION}|cut -c1)" == 'r' ]; then
+ REV=$(echo ${VERSION} | cut -c2-)
+ else
+ REV="branch_${VERSION}"
+ fi
+ RETDIR=$(pwd)
+ mkdir -p $CODIR/${PRGNAM}_temp_checkout_$$ \
+ && cd $CODIR/${PRGNAM}_temp_checkout_$$
+ mkdir ${PBASE} \
+ && cd ${PBASE} \
+ && hg clone https://rawtherapee.googlecode.com/hg/ . \
+ && hg update ${REV} \
+ && echo "export HG_BRANCH=$(hg -R . branch)" > slackinfo \
+ && echo "export HG_VERSION=$(hg parents --template={latesttag}.{latesttagdistance})" >> slackinfo \
+ && echo "export HG_CHANGESET=$(hg parents --template={node\|short})" >> slackinfo \
+ && echo "export HG_TAGDISTANCE=$(hg parents --template={latesttagdistance})" >> slackinfo \
+ && find . -type d -name '.hg' -depth | xargs rm -rf \
+ && chown -R root:root . \
+ && cd .. \
+ && tar -${TARCOMP}cf ${2} ${PBASE}
+ cd $RETDIR
+ rm -rf $CODIR/${PRGNAM}_temp_checkout_$$ || true
+ ;;
+ *) # Do nothing
+ ;;
+ esac
+}
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ *) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename ${SOURCE})"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Fail to download '$(basename ${SOURCE})'. Aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ # Try if we have a SVN/CVS download routine for ${SOURCE}
+ echo "Will checkout sources to $(dirname $SOURCE)"
+ src_checkout 0 "${SOURCE}" 2>&1 > $OUTPUT/checkout-$(basename ${SOURCE}).log
+ fi
+ if [ ! -f "${SOURCE}" -o ! -s "${SOURCE}" ]; then
+ echo "File '$(basename ${SOURCE})' not available. Aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}
+
+# The rtstart wrapper is useless now:
+sed -i -e "s|install (PROGRAMS rtstart|\#install (PROGRAMS rtstart|" \
+ CMakeLists.txt
+
+# Define variables taken from the mercury repository at checkout:
+eval $(cat slackinfo)
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+X-s .
+
+echo Building ...
+mkdir -p build
+cd build
+ cmake .. \
+ -DAUTOMATED_BUILD_SYSTEM:BOOL=OFF \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+ -DCMAKE_BUILD_TYPE=Release \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIBDIR=/usr/lib${LIBDIRSUFFIX} \
+ -DBUILD_SHARED_LIBS:BOOL=ON \
+ 2>&1 | tee $OUTPUT/cmake-${PRGNAM}.log
+
+ make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+ make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+cd -
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Update the desktop database:
+if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
+fi
+
+# Update hicolor theme cache:
+if [ -d usr/share/icons/hicolor ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
+ fi
+fi
+
+# Update the mime database:
+if [ -x usr/bin/update-mime-database ]; then
+ chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+rm -rf $PKG/usr/share/doc # Redundant
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+ cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/rawtherapee/build/slack-desc b/rawtherapee/build/slack-desc
new file mode 100644
index 00000000..a747ffd6
--- /dev/null
+++ b/rawtherapee/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+rawtherapee: rawtherapee (Raw image processing software)
+rawtherapee:
+rawtherapee: RawTherapee is a cross platform image processing software equipped
+rawtherapee: with the essential tools for high quality and efficient
+rawtherapee: RAW photo development.
+rawtherapee:
+rawtherapee:
+rawtherapee:
+rawtherapee:
+rawtherapee: rawtherapee home: http://rawtherapee.com/
+rawtherapee:
diff --git a/rawtherapee/build/slack-required b/rawtherapee/build/slack-required
new file mode 100644
index 00000000..a8bd58a1
--- /dev/null
+++ b/rawtherapee/build/slack-required
@@ -0,0 +1,5 @@
+glibmm
+gtkmm
+libsigc++
+libiptcdata
+